/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			MacZoop.h			-- standard defines and globals, always present. You can
*									precompile this if you want.
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __MACZOOP__
#define	__MACZOOP__

#include	<QDOffscreen.h>
#include	<CodeFragments.h>
#include	<drag.h>
#include	<AppleEvents.h>
#include	<Quickdraw.h>
#include	<Gestalt.h>

#include	"ZDefines.h"
#include	"ZErrors.h"
#include	"ZApplication.h"
#include	"ZWindowManager.h"
#include	"ZClipboard.h"
#include	"ZMenuBar.h"

#include	"CursorUtilities.h"


/************************************************************************************************/

// MacZoop reserves commands numbered 1-127 for the standard menu commands such as
// New, Open, Quit, Cut, Paste, etc. Your own commands should be numbered 128 and higher. You
// can use any command you wish for any purpose- MacZoop is ignorant of meanings attached to
// command numbers themselves. Since the command mapping tables are built on the fly at start-up,
// you are free to reorganise the menus however you want to suit your application- MacZoop will
// handle any standard commands present in the default manner, but doesn't care if they're not
// there, etc. This allows great flexibility in organising your application. Caveat: don't add
// items to the Apple Menu unless you are prepared to override the standard command handling.


// Standard commands:

enum
{
	kNoCmd = 0,					// 0
	kCmdAbout = 1,				// 1
	kCmdNew,					// 2
	kCmdOpen,					// 3
	kCmdClose,					// 4
	kCmdCloseAll,				// 5
	kCmdSave,					// 6
	kCmdSaveAs,					// 7
	kCmdRevert,					// 8
	kCmdPageSetup,				// 9
	kCmdPrint,					// 10
	kCmdQuit,					// 11
	kCmdUndo,					// 12
	kCmdCut,					// 13
	kCmdCopy,					// 14
	kCmdPaste,					// 15
	kCmdClear,					// 16
	kCmdSelectAll,				// 17
	kCmdSelectNone,				// 18
	kCmdPlainText,				// 19
	kCmdBoldText,				// 20
	kCmdItalicText,				// 21
	kCmdUnderlineText,			// 22
	kCmdOutlineText,			// 23
	kCmdShadowText,				// 24
	kCmdCondensedText,			// 25
	kCmdExtendedText			// 26
};


// Global objects accessible from all classes:

extern	ZApplication*		gApplication;		// the application object
extern	ZWindowManager*		gWindowManager;		// the window manager object
extern	ZMenuBar*			gMenuBar;			// the main menubar object
extern	ZClipboard*			gClipboard;			// the clipboard object

// Other globals

extern	OSType				gAppSignature;		// creator type of this application	
extern	Boolean				gIsAColourMac;		// TRUE if we have any form of colour QD
extern	tMacInfo			gMacInfo;			// other common gestalt results	

// static code called to kick the whole thing into life:

void	RunApplication();


#endif