/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZEventHandler.h		-- the event handler object
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#pragma once

#ifndef __ZEVENTHANDLER__
#define __ZEVENTHANDLER__

#include	<AppleEvents.h>


class	ZWindow;
class	ZCommander;


class	ZEventHandler
{
protected:
	short			clicks;				// number of mouse-clicks in a series
	EventRecord		theEvent;			// the event recovered from queue
	Boolean			inBackground;		// TRUE if app in background

public:

	ZEventHandler();
	
	virtual void	GetAnEvent( const short mask = everyEvent );
	virtual void	DispatchAnEvent();
	virtual void	InstallApplescriptHandlers();
	virtual void	InstallAppleEventHandler( const AEEventClass pClass, const AEEventID pID );

	virtual void	HandleWindowUpdate( const WindowPtr theWindow );
	virtual void	HandleWindowActivate( const WindowPtr theWindow, const Boolean state );
	
protected:
	virtual void	CountClicks(const WindowPtr target, const long clickTicks, const Point globalMouse );
	virtual void	HandleMouseEvent( const EventRecord& theEvent );
	virtual void	HandleKeyEvent( const char theKey, const Boolean isAutoKey );
	virtual void	PassIdle();
	virtual void	HandleHLEvent( const EventRecord& theEvent);
	virtual void	HandleOSEvent( const EventRecord& theEvent);
	
	virtual void	ProcessDialogEvent( const DialogPtr theDialog, const short itemHit);
	virtual Boolean	PrefilterDialogEvent();

public:	
	inline short	GetClicks(){ return clicks;};
	inline Boolean	InBackground(){ return inBackground;};
	inline void		GetLatestEvent( EventRecord* anEvent ) { *anEvent = theEvent; };
};



extern		short			gSleep;
extern		ZCommander*		gCurHandler;


#define		kFrontSleep		LMGetCaretTime()
#define		kBackSleep		(kFrontSleep << 2)


#endif